<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Tugas Component</title>
    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
</head>
<body>
    <div id="app">
        <component-form 
            :formuser='formUser' 
            :editbutton='editButton'
            @add-user='addUser()' 
            @update-user='updateUser()'
            @inputformuser='inputformuser($event)'
        >
        </component-form>
        <br>
        <component-user 
            :users='users' 
            :reverseUsers='reverseUsers' 
            :idSelected='idSelected'
            @edit-user='editUser($event)' 
            @delete-user='deleteUser($event)'
        >
        </component-user>
        
    </div>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"> </script>
    <script>
        const ComponentForm = {
            template:`
            <div class="formInput">
                <input type="text" v-model="userform" @input="$emit('inputformuser',userform)">
                <button v-if="!editbutton" @click="$emit('add-user')">
                    add </button>
                <button v-if="editbutton" @click="$emit('add-user')">
                    update </button>
            </div>
            `,
            props: ['formuser', 'editbutton'],
            watch: {
                formuser: function (newVal, oldVal){
                    this.userform = newVal
                },
            },
                data(){
                    return {
                        userform: ''
                    }
                },
                methods: {
                    inputuser (){
                        this.$emit('inputformuser',this.userform)
                        this.userform = ""
                    }
                }
            
        }
        const ComponentUser = {
            template :`
            <div class="userList">
                <ul>
                    <li v-fors"(user, index) in reverseUsers" :key="index">
                        {{user.name}} ||
                        <button @click="$emit('edit-user', index)">Edit</button>
                        <button @click="$emit('delete-user, index')">Delete</button>

                    </li>
                </ul>
            </div>
            `,
            props: ['users', 'reverseUsers', 'idselected'],
            watch: {

            },
            data(){
                return{

                }
            },
        }

        let vm = new Vue({
            el: '#app',
            components: {
                'component-form': ComponentForm,
                'component-user' : ComponentUser
            },
            data: {
                users: [
                    { name: 'Muhammad Iqbal Mubarok' },
                    { name: 'Ruby Purwanti' },
                    { name: 'Faqih Muhammad' },
                ],
                formUser: '',
                editButton: false,
                idSelected: null
            },
            computed: {
                reverseUsers: {
                    get: function () {
                        return this.users.slice().reverse()
                    },
                    set: function (value) {
                        this.users = value.slice().reverse()
                    }
                }
            },
            methods: {
                addUser: function () {
                    this.users.push({ name: this.formUser })
                    this.formUser = ''
                },
                editUser: function (id) {
                    this.formUser = this.reverseUsers[id].name
                    this.editButton = true,
                    this.idSelected = id
                },
                updateUser: function () {
                    this.reverseUsers[this.idSelected].name = this.formUser
                    this.formUser = ''
                    this.editButton = false
                },
                deleteUser: function (id) {
                    let confirmation = confirm("Anda yakin ?")
                    if (confirmation) {
                        this.reverseUsers = this.reverseUsers.filter(function (item, index) {
                            return index != id
                        })
                    }
                },
                inputFormUser: function (formuser) {


                this.formUser = formuser


}   
            }
        })
    </script>
</body>
</html>